//------------------------------------------------------------------------------//
//				AXC-PL01_SAMPLE3_OUTPUT Module  V1.20					//
//			CompactFlash CF+ Programmable Logic CARD					//
//					ADTEK SYSTEM SCIENCE CO.,LTD.						//
//				Since 2005/01/13  LAST UPDATE 2005/11/07				//
//						<< S3_OUTPUT U2 >>							//
//------------------------------------------------------------------------------//

//------------------------------------------------------------------------------//
//	Module	C_ -> CompactFlash, L_ ->LocalSignal, P -> PIO Signal			//
//			n  -> Active Low Signal									//
//------------------------------------------------------------------------------//

module S3_OUTPUT

	(	C_DATA_IO,
		IO_DATAOUT_I,
		IO_DATAOUT_EN_I,
		IO_DATAOUT_SEL_I,
		IO_DATA_IO,
		C_DATAOUT_I,
		C_DATAOUT_EN_I,
		L_125GEN,
		IO_DATAIN_O,
		C_DATAIN_O
	);


//-----------------------Inout Signal Definition--------------------------------//

	inout	[13:0] C_DATA_IO;					// CompactFlash CARD DATA
											// Card Bus  U2


//-----------------------Input Signal Definition--------------------------------//


 	input	[13:0] IO_DATAOUT_I;				// Data Register 
											// OIOւOUTDATA̓
											// U1  U2

	input	[13:0] IO_DATAOUT_EN_I;				// PIO Output Enable Register 
											// OIOւOUTDATA Enable
											// U1  U2,U3

	input	[13:0] IO_DATAOUT_SEL_I;				// PIO OUTPUT Sellect(OC or OUT) Register
											// OIOւOD/OUT؂ւ
											// U1  U2

	inout	[13:0] IO_DATA_IO;					// Parallel I/O
											// PIO Side Bus  U2

	input	[13:0] C_DATAOUT_I;					// CompactFlash DATA o͐M
											// U3  U2

	input	[1:0] C_DATAOUT_EN_I;				// CompactFlash DATA OUT Enable
											// CARD DATA OUT ENABLE
											// U3  MAIN,U2

	input	L_125GEN;							// Write Mode Switch
											// MAIN  U1,U2


//-----------------------Output Signal Definition-------------------------------//

	output	[13:0] IO_DATAIN_O;					// OIO͂DATA
											// U2  U3,U4

	output	[13:0] C_DATAIN_O;					//  CompactFlash DATA Buses 
											// U2  U0,U1,U4

//-----------------------WIRE Definition----------------------------------------// 
							
 	wire		[13:0] IO_DATAOUT_I;

	wire		[13:0] IO_DATAOUT_EN_I;

	wire		[13:0] IO_DATAOUT_SEL_I;

 	wire		[13:0] IO_DATA_IO;

	wire		[13:0] n_dout;						// sellectDOUT									


//------OoI/O po͐ݒ


	wire		[13:0] n_iodata_o;					// OIOւ̏o͐M
	wire		[13:0] n_iodata_o_en;				// OIOւ̏oEnable
	wire		[13:0] IO_DATAIN_O;					// OIO̓



//------------------------------------------------------------------------------//
//		PIO Side IN/OUT ؑ֗p IO Buffer								//
//			IOHiZ̎IO̊OڑDɓ͂܂B				//
//				I :n_iodata_o		:CompactFlash DATA o͐M			//
//				E :n_iodata_o_en	:CompactFlash DATA OUT Enable			//
//				IO:IO_DATA_IO		:CompactFlash CARD DATA				//			
// 				O :IO_DATAIN_O		: CompactFlash DATA Buses			//
// 																//
// 			 													//
// 							+-----+------++------+-----+				//
// 		E-----+				|  E  |	I  ||  IO  |  O  |				//
//		      |			 	======+======++======+=====+				//
//		I____|________IO		|  1  |	X  ||   Z  |  X  |				//
//		     |^    |			+-----+------++------+-----+				//
//		@@@@@  |			|  0  |	1  ||   1  |  1  |				//
//		D____^|____|			+-----+------++------+-----+				//
//		     _|				|  0  |	0  ||   0  |  0  |				//
// 							+-----+------++------+-----+				//
// 																//
//------------------------------------------------------------------------------//


//---- n_dout ̏
// IO_DATAOUT_SEL_ILowiI[uhC[hj̎̓IO_DATAOUT_IŐ؂ւ܂B

	assign n_dout[13]	= (IO_DATAOUT_I[13])? 1'bZ : 0 ;
	assign n_dout[12]	= (IO_DATAOUT_I[12])? 1'bZ : 0 ;
	assign n_dout[11]	= (IO_DATAOUT_I[11])? 1'bZ : 0 ;
	assign n_dout[10]	= (IO_DATAOUT_I[10])? 1'bZ : 0 ;
	assign n_dout[9]	= (IO_DATAOUT_I[9])?  1'bZ : 0 ;
	assign n_dout[8]	= (IO_DATAOUT_I[8])?  1'bZ : 0 ;
	assign n_dout[7]	= (IO_DATAOUT_I[7])?  1'bZ : 0 ;
	assign n_dout[6]	= (IO_DATAOUT_I[6])?  1'bZ : 0 ;
	assign n_dout[5]	= (IO_DATAOUT_I[5])?  1'bZ : 0 ;
	assign n_dout[4]	= (IO_DATAOUT_I[4])?  1'bZ : 0 ;
	assign n_dout[3]	= (IO_DATAOUT_I[3])?  1'bZ : 0 ;
	assign n_dout[2]	= (IO_DATAOUT_I[2])?  1'bZ : 0 ;
	assign n_dout[1]	= (IO_DATAOUT_I[1])?  1'bZ : 0 ;
	assign n_dout[0]	= (IO_DATAOUT_I[0])?  1'bZ : 0 ;


//--- n_iodata_o ̏
// IÕV

	assign n_iodata_o[13]	= (IO_DATAOUT_SEL_I[13])? IO_DATAOUT_I[13]:n_dout[13];
	assign n_iodata_o[12]	= (IO_DATAOUT_SEL_I[12])? IO_DATAOUT_I[12]:n_dout[12];
	assign n_iodata_o[11]	= (IO_DATAOUT_SEL_I[11])? IO_DATAOUT_I[11]:n_dout[11];
	assign n_iodata_o[10]	= (IO_DATAOUT_SEL_I[10])? IO_DATAOUT_I[10]:n_dout[10];
	assign n_iodata_o[9]	= (IO_DATAOUT_SEL_I[9])?  IO_DATAOUT_I[9]:n_dout[9];
	assign n_iodata_o[8]	= (IO_DATAOUT_SEL_I[8])?  IO_DATAOUT_I[8]:n_dout[8];
	assign n_iodata_o[7]	= (IO_DATAOUT_SEL_I[7])?  IO_DATAOUT_I[7]:n_dout[7];
	assign n_iodata_o[6]	= (IO_DATAOUT_SEL_I[6])?  IO_DATAOUT_I[6]:n_dout[6];
	assign n_iodata_o[5]	= (IO_DATAOUT_SEL_I[5])?  IO_DATAOUT_I[5]:n_dout[5];
	assign n_iodata_o[4]	= (IO_DATAOUT_SEL_I[4])?  IO_DATAOUT_I[4]:n_dout[4];
	assign n_iodata_o[3]	= (IO_DATAOUT_SEL_I[3])?  IO_DATAOUT_I[3]:n_dout[3];
	assign n_iodata_o[2]	= (IO_DATAOUT_SEL_I[2])?  IO_DATAOUT_I[2]:n_dout[2];
	assign n_iodata_o[1]	= (IO_DATAOUT_SEL_I[1])?  IO_DATAOUT_I[1]:n_dout[1];
	assign n_iodata_o[0]	= (IO_DATAOUT_SEL_I[0])?  IO_DATAOUT_I[0]:n_dout[0];


//--- n_iodata_o_en ̏

	assign n_iodata_o_en[13]	= L_125GEN | IO_DATAOUT_EN_I[13];
	assign n_iodata_o_en[12]	= L_125GEN | IO_DATAOUT_EN_I[12];
	assign n_iodata_o_en[11]	= L_125GEN | IO_DATAOUT_EN_I[11];
	assign n_iodata_o_en[10]	= L_125GEN | IO_DATAOUT_EN_I[10];
	assign n_iodata_o_en[9]	= L_125GEN | IO_DATAOUT_EN_I[9];
	assign n_iodata_o_en[8]	= L_125GEN | IO_DATAOUT_EN_I[8];
	assign n_iodata_o_en[7]	= L_125GEN | IO_DATAOUT_EN_I[7];
	assign n_iodata_o_en[6]	= L_125GEN | IO_DATAOUT_EN_I[6];
	assign n_iodata_o_en[5]	= L_125GEN | IO_DATAOUT_EN_I[5];
	assign n_iodata_o_en[4]	= L_125GEN | IO_DATAOUT_EN_I[4];
	assign n_iodata_o_en[3]	= L_125GEN | IO_DATAOUT_EN_I[3];
	assign n_iodata_o_en[2]	= L_125GEN | IO_DATAOUT_EN_I[2];
	assign n_iodata_o_en[1]	= L_125GEN | IO_DATAOUT_EN_I[1];
	assign n_iodata_o_en[0]	= L_125GEN | IO_DATAOUT_EN_I[0];


//  I/Odata o͒`

	assign	 IO_DATA_IO[13] = (n_iodata_o_en[13])?	1'bZ : n_iodata_o[13];
	assign	 IO_DATA_IO[12] = (n_iodata_o_en[12])?	1'bZ : n_iodata_o[12];
	assign	 IO_DATA_IO[11] = (n_iodata_o_en[11])?	1'bZ : n_iodata_o[11];
	assign	 IO_DATA_IO[10] = (n_iodata_o_en[10])?	1'bZ : n_iodata_o[10];
	assign	 IO_DATA_IO[9] = (n_iodata_o_en[9])?	1'bZ : n_iodata_o[9];
	assign	 IO_DATA_IO[8] = (n_iodata_o_en[8])?	1'bZ : n_iodata_o[8];
	assign	 IO_DATA_IO[7] = (n_iodata_o_en[7])?	1'bZ : n_iodata_o[7];
	assign	 IO_DATA_IO[6] = (n_iodata_o_en[6])?	1'bZ : n_iodata_o[6];
	assign	 IO_DATA_IO[5] = (n_iodata_o_en[5])?	1'bZ : n_iodata_o[5];
	assign	 IO_DATA_IO[4] = (n_iodata_o_en[4])?	1'bZ : n_iodata_o[4];
	assign	 IO_DATA_IO[3] = (n_iodata_o_en[3])?	1'bZ : n_iodata_o[3];
	assign	 IO_DATA_IO[2] = (n_iodata_o_en[2])?	1'bZ : n_iodata_o[2];
	assign	 IO_DATA_IO[1] = (n_iodata_o_en[1])?	1'bZ : n_iodata_o[1];
	assign	 IO_DATA_IO[0] = (n_iodata_o_en[0])?	1'bZ : n_iodata_o[0];


//  IOdata Ddata ڑ`
	
	assign	IO_DATAIN_O[13:0]	= IO_DATA_IO[13:0];


//------------------------------------------------------------------------------//
//		CompactFlash CARD DATA IN/OUT ؑ֗p IO Buffer					//
//			IOHiZ̎IO̊OڑDɓ͂܂B				//
//				I :C_DATAOUT_I		:CompactFlash DATA o͐M			//
//				E :C_DATAOUT_EN_I	:CompactFlash DATA OUT Enable			//
//				IO:C_DATA_IO		:CompactFlash CARD DATA				//			
// 				O :C_DATAIN_O		: CompactFlash DATA Buses			//
// 																//
// 		IOBUFE 													//
// 							+-----+------++------+-----+				//
// 		E-----+				|  E  |	I  ||  IO  |  O  |				//
//		      |			 	======+======++======+=====+				//
//		I____|________IO		|  1  |	X  ||   Z  |  X  |				//
//		     |^    |			+-----+------++------+-----+				//
//		@@@@@  |			|  0  |	1  ||   1  |  1  |				//
//		D____^|____|			+-----+------++------+-----+				//
//		     _|				|  0  |	0  ||   0  |  0  |				//
// 							+-----+------++------+-----+				//
// 																//
//------------------------------------------------------------------------------//


	IOBUFE CIOBUF13(.O(C_DATAIN_O[13]),.IO(C_DATA_IO[13]),.I(C_DATAOUT_I[13]),.E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF12(.O(C_DATAIN_O[12]),.IO(C_DATA_IO[12]),.I(C_DATAOUT_I[12]),.E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF11(.O(C_DATAIN_O[11]),.IO(C_DATA_IO[11]),.I(C_DATAOUT_I[11]),.E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF10(.O(C_DATAIN_O[10]),.IO(C_DATA_IO[10]),.I(C_DATAOUT_I[10]),.E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF9 (.O(C_DATAIN_O[9]), .IO(C_DATA_IO[9]), .I(C_DATAOUT_I[9]), .E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF8 (.O(C_DATAIN_O[8]), .IO(C_DATA_IO[8]), .I(C_DATAOUT_I[8]), .E(C_DATAOUT_EN_I[1]));
	IOBUFE CIOBUF7 (.O(C_DATAIN_O[7]), .IO(C_DATA_IO[7]), .I(C_DATAOUT_I[7]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF6 (.O(C_DATAIN_O[6]), .IO(C_DATA_IO[6]), .I(C_DATAOUT_I[6]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF5 (.O(C_DATAIN_O[5]), .IO(C_DATA_IO[5]), .I(C_DATAOUT_I[5]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF4 (.O(C_DATAIN_O[4]), .IO(C_DATA_IO[4]), .I(C_DATAOUT_I[4]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF3 (.O(C_DATAIN_O[3]), .IO(C_DATA_IO[3]), .I(C_DATAOUT_I[3]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF2 (.O(C_DATAIN_O[2]), .IO(C_DATA_IO[2]), .I(C_DATAOUT_I[2]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF1 (.O(C_DATAIN_O[1]), .IO(C_DATA_IO[1]), .I(C_DATAOUT_I[1]), .E(C_DATAOUT_EN_I[0]));
	IOBUFE CIOBUF0 (.O(C_DATAIN_O[0]), .IO(C_DATA_IO[0]), .I(C_DATAOUT_I[0]), .E(C_DATAOUT_EN_I[0]));

//------------------------------------------------------------------------------//

endmodule

